package gregapi.tileentity;


/**
 * @author Gregorius Techneticies
 */
public interface ITileEntityFoamable extends ITileEntityUnloadable {
	/** @return if it got applied successfully. */
	public boolean applyFoam(byte aSide, short[] aCFoamRGB, byte aVanillaColor);
	
	/** @return if it got dried successfully. */
	public boolean dryFoam(byte aSide);
	
	/** @return if it got removed successfully. */
	public boolean removeFoam(byte aSide);
	
	/** @return if it is foamed. */
	public boolean hasFoam(byte aSide);
	
	/** @return if it is dried. */
	public boolean driedFoam(byte aSide);
}